package cn.timer.api.dao.disk;


import cn.timer.api.bean.disk.DiskFiles;
import cn.timer.api.config.annotation.UserBean;
import cn.timer.api.dto.disk.DiskCatalogueParam;
import cn.timer.api.dto.disk.DiskFileCatalogueDto;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import org.apache.ibatis.annotations.Param;
import org.springframework.stereotype.Repository;

import java.util.List;

/**
 * 云盘-资源上传文件表
 *
 * @author wuqingjun
 * @email 284718418@qq.com
 * @date 2021-12-27 10:05:49
 */
@Repository
public interface DiskFilesMapper extends BaseMapper<DiskFiles> {


    /**
     * 我的文件夹
     * @param diskCatalogueParam
     * @return
     */
    List<DiskFiles> selectListByParam(@Param("param")DiskCatalogueParam diskCatalogueParam);

    /**
     * 获取用户文件空间大小
     * @param userBean
     * @return
     */
    DiskFileCatalogueDto selectFileCount(@Param("param") UserBean userBean,@Param("type")Integer type);

    /**
     * 删除文件
     * @param list
     * @return
     */
    Integer deleteDiskFile(@Param("list") List<Integer> list);

}
